theory ExecuteTPOD
  imports Execute
begin

definition \<open>execute\<^sub>T\<^sub>P\<^sub>O\<^sub>D \<pi>\<^sub>1 \<pi>\<^sub>2 \<pi>\<^sub>3 \<pi>\<^sub>4 \<longleftrightarrow> 
  execute \<pi>\<^sub>1 \<pi>\<^sub>2 \<pi>\<^sub>3 \<pi>\<^sub>4 \<and>
  (hd \<pi>\<^sub>3) \<approx>\<^sub>\<L> (hd \<pi>\<^sub>4) \<and>
  \<not>speculating (hd \<pi>\<^sub>1) \<and> \<not>speculating (hd \<pi>\<^sub>2) \<and>
  \<not>speculating (hd \<pi>\<^sub>3) \<and> \<not>speculating (hd \<pi>\<^sub>4)
\<close>


subsection \<open>Adversarial Proofs.\<close>

text \<open>Prove that for a full execution under the assumption of TPOD (execute_{TPOD}), the adversary 
      model holds.\<close>

end